#include "ddr.hh"
#include <iostream>

using namespace std;

int main()
{
  DigitalDataRate ddr(100);
  
  srandom(time(0));

  struct timeval tv;

  cout<<"Adding 100 values 0, 100, 200 ... 10000\n";
  for(unsigned int n=0;n<100;++n) {
    tv.tv_sec=n;
    ddr.feed(100*n, &tv);
  }
  ddr.printStatus();

  cout<<"Measured rate over past 10 seconds: "<<ddr.getAverage(10, &tv)<<endl;
  cout<<"Measured rate over past 20 seconds: "<<ddr.getAverage(20, &tv)<<endl;
  cout<<"Measured rate over past 200 seconds: "<<ddr.getAverage(200, &tv)<<endl;
  cout<<"Measured rate over past 1 second: "<<ddr.getAverage(1, &tv)<<endl;
  cout<<"Skipping time by 10 seconds"<<endl;
  tv.tv_sec+=10;
  cout<<"Measured rate over past 5 seconds: "<<ddr.getAverage(5, &tv)<<endl;
  ddr.printStatus();
  cout<<"Measured rate over past 10 seconds: "<<ddr.getAverage(10, &tv)<<endl;
  cout<<"Measured rate over past 20 seconds: "<<ddr.getAverage(20, &tv)<<endl;

}
